<template>
	<div class="statistics-order-zg-visit-count-container layout-padding">
		<div class="layout-padding-auto layout-padding-view pd20">
			<el-form :model="state.queryParams" ref="ruleFormRef" @submit.native.prevent inline>
				<el-form-item prop="crTime">
					<statistical-time v-model="state.queryParams.crTime" @change="handleQuery" ref="statisticalTimeRef" :disabled="state.loading" />
				</el-form-item>
				<el-form-item label="回访员" prop="EmployeeName">
					<el-input v-model="state.queryParams.EmployeeName" placeholder="回访员名称" clearable @keyup.enter="handleQuery" class="keyword-input" />
				</el-form-item>
				<el-form-item>
					<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
					<el-button @click="resetQuery(ruleFormRef)" class="default-button" :loading="state.loading">
						<SvgIcon name="ele-Refresh" class="mr5" />重置
					</el-button>
					<el-popover :width="500" trigger="click">
						<template #reference>
							<el-button type="primary" title="口径说明"><SvgIcon name="ele-QuestionFilled" class="mr5" />口径说明</el-button>
						</template>
						<el-descriptions title="" :column="1" border style="max-height: 400px; overflow: auto">
							<el-descriptions-item label="注意">以回访时间为准</el-descriptions-item>
							<el-descriptions-item label="电话回访量">坐席回访时，点击“外拨”并完成回访的数据；</el-descriptions-item>
							<el-descriptions-item label="默认回访量">坐席批量回访的数据或未点击“外拨”而完成的回访数据；</el-descriptions-item>
							<el-descriptions-item label="注意"
								><el-text type="danger">电话回访量和人工回访量与信件转部门办件量无必然关系</el-text></el-descriptions-item
							>
						</el-descriptions>
					</el-popover>
				</el-form-item>
			</el-form>
			<vxe-toolbar
				ref="toolbarRef"
				:loading="state.loading"
				custom
				:refresh="{
					queryMethod: handleQuery,
				}"
				:tools="[{ toolRender: { name: 'exportAll' } }]"
			>
			</vxe-toolbar>
			<div style="overflow: hidden; width: 100%; height: 100%; flex: 1">
				<vxe-table
					border
					:loading="state.loading"
					:data="state.tableData"
					:column-config="{ resizable: true }"
					:row-config="{ isCurrent: true, isHover: true, height: 30, useKey: true }"
					ref="tableRef"
					height="auto"
					auto-resize
					:scrollY="{ enabled: true, gt: 100 }"
					show-overflow
					id="statisticsOrderZGVisitCount"
					:custom-config="{ storage: true }"
					show-footer
					:footer-method="footerMethod"
					:params="{ exportMethod: departmentVisitZGExport, exportParams: requestParams }"
				>
					<vxe-column field="employeeName" title="回访员"></vxe-column>
					<vxe-column field="callVisitCount" title="电话回访量" sortable> </vxe-column>
					<vxe-column field="defaultVisitCount" title="默认回访量" sortable></vxe-column>
					<vxe-column field="smsVisitCount" title="短信回访量" sortable></vxe-column>
					<vxe-column field="totalVisitCount" title="总回访量" sortable></vxe-column>
				</vxe-table>
			</div>
		</div>
	</div>
</template>
<script setup lang="tsx" name="statisticsOrderZGVisitCount">
import { defineAsyncComponent, onMounted, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { departmentVisitZG, departmentVisitZGExport } from '@/api/statistics/order';
import { defaultDate } from '@/utils/constants';
import Other from '@/utils/other';
import XEUtils from 'xe-utils';

const StatisticalTime = defineAsyncComponent(() => import('@/components/StatisticalTime/index.vue')); // 日期类型选择组件
const ruleFormRef = ref<RefType>(); // 表单ref
const state = reactive<any>({
	queryParams: {
		// 查询条件
		EmployeeName: null, // 话务员名称
		crTime: defaultDate, // 时间默认今天开始到今天结束
	},
	tableData: [],
	loading: false, // 加载
	total: 0, // 总数
	data: {
		aiVisitCount: 0,
		aiVisitSatisfiedCount: 0,
		aiVisitNoSatisfiedCount: 0,
		aiVisitFailCount: 0,
	},
});
/** 搜索按钮操作 */
const handleQuery = () => {
	// state.queryParams.PageIndex = 1;
	queryList();
};
/** 获取列表 */
const requestParams = ref<EmptyObjectType>({});
const queryList = () => {
	state.loading = true;
	requestParams.value = Other.deepClone(state.queryParams);
	requestParams.value.StartTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[0];
	requestParams.value.EndTime = state.queryParams.crTime === null ? null : state.queryParams.crTime[1];
	Reflect.deleteProperty(requestParams.value, 'crTime');
	departmentVisitZG(requestParams.value)
		.then((res: any) => {
			state.tableData = res.result ?? [];
			state.data = res.result ?? {};
			state.loading = false;
		})
		.catch(() => {
			state.loading = false;
		});
};
/** 重置按钮操作 */
const statisticalTimeRef = ref<RefType>();
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	statisticalTimeRef.value.reset();
	queryList();
};
// 查看详情
// 计算合计
const footerMethod = ({ columns, data }) => {
	return [
		columns.map((column: any, columnIndex: number) => {
			if (columnIndex === 0) {
				return '合计';
			}
			if (['callVisitCount', 'defaultVisitCount', 'smsVisitCount', 'totalVisitCount'].includes(column.property)) {
				return XEUtils.sum(data, column.property);
			}
		}),
	];
};
const toolbarRef = ref<RefType>();
const tableRef = ref<RefType>();
onMounted(() => {
	queryList();
	if (tableRef.value && toolbarRef.value) {
		tableRef.value.connect(toolbarRef.value);
	}
});
</script>
